package ui;
/*
 * This file is released to the public domain using the CC0 1.0 license.
 * The full text of the license can be found at
 * https://creativecommons.org/publicdomain/zero/1.0/legalcode
 */

import java.net.URL;
import javax.swing.ImageIcon;

abstract class IconCollection
{

    public static final ImageIcon ZOOMMOVE, ZOOMORG, EDIT, HIDE, CLOSE16, TABICON,
                                  THUMBNAIL, ZOOMIN16, ZOOMOUT16, ZOOMORG16;
    private static final String[] m_image_paths = new String[]{"imgs/"};

    static
    {
        CLOSE16 = readIcon("close16.png");
        ZOOMIN16 = readIcon("zoomin16.png");
        ZOOMOUT16 = readIcon("zoomout16.png");
        ZOOMORG16 = readIcon("zoomorg16.png");
        TABICON = readIcon("tab-icon.png");
        THUMBNAIL = readIcon("thumbnails.png");
        ZOOMMOVE = readIcon("zoommove.png");
        ZOOMORG = readIcon("zoomorg.png");
        EDIT = readIcon("edit.png");
        HIDE = readIcon("filaments.png");
    }

    private static ImageIcon readIcon(String file)
    {
        URL url;

        for (String path : m_image_paths)
        {
            if ((url = IconCollection.class.getClassLoader().getResource(path + file)) != null)
            {
                return new ImageIcon(url);
            }
        }

        System.err.println("Icon " + file + " not found!");
        return null;
    }
}
